; Rubiks Cube-2.6 Rel. 0.2 Created by graechan
; Comments directed to http://gimpchat.com or http://gimpscripts.com
;
; License: GPLv3
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;    GNU General Public License for more details.
;
;    To view a copy of the GNU General Public License
;    visit: http://www.gnu.org/licenses/gpl.html
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;GMIC info;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;   Copyright   : David Tschumperle
;;                 ( http://www.greyc.ensicaen.fr/~dtschump/  )
;;
;;   License     : CeCILL v2.0
;;                 ( http://www.cecill.info/licences/Licence_CeCILL_V2-en.html  )
;;
;;   This software is governed by the CeCILL  license under French law and
;;   abiding by the rules of distribution of free software.  You can  use,
;;   modify and/ or redistribute the software under the terms of the CeCILL
;;   license as circulated by CEA, CNRS and INRIA at the following URL
;;   "http://www.cecill.info ".
;;
;;   As a counterpart to the access to the source code and  rights to copy,
;;   modify and redistribute granted by the license, users are provided only
;;   with a limited warranty  and the software's author,  the holder of the
;;   economic rights,  and the successive licensors  have only  limited
;;   liability.
;;
;;   In this respect, the user's attention is drawn to the risks associated
;;   with loading,  using,  modifying and/or developing or reproducing the
;;   software by the user in light of its specific status of free software,
;;   that may mean  that it is complicated to manipulate,  and  that  also
;;   therefore means  that it is reserved for developers  and  experienced
;;   professionals having in-depth computer knowledge. Users are therefore
;;   encouraged to load and test the software's suitability as regards their
;;   requirements in conditions enabling the security of their systems and/or
;;   data to be ensured and,  more generally, to use and operate it in the
;;   same conditions as regards security.
;;
;;   The fact that you are presently reading this means that you have had
;;   knowledge of the CeCILL license and that you accept its terms.
;    
;
;
;
; ------------
;| Change Log |
; ------------ 
; Rel 0.01 - Initial Release
; Rel 0.02 - Added animation option 
; 
;;;;
(define (script-fu-rubiks-cube image drawable
                               in-frames)
							  

 (let* (
            (image-layer (car (gimp-image-get-active-layer image)))
			(width (car (gimp-image-width image)))
			(height (car (gimp-image-height image)))
			(image-channel 0)
			(stencil-layer 0)
			(stencil-channel 0)
			(selblur-layer 0)
			(gloss-layer 0)
        )
	
	
	(gimp-context-push)
    (gimp-image-undo-group-start image)
	(gimp-context-set-foreground '(0 0 0))
	(gimp-context-set-background '(255 255 255))
	(gimp-layer-add-alpha image-layer)
	
;;;;square up the Image if needed	
    (if (< height width) (set! height width))
	(if (< width height) (set! width height))

;;;;Scale the image	
	(gimp-image-scale-full image width height 2)
	

	
;;;;create the stencil layer
	(set! stencil-layer (car (gimp-layer-new image width height  RGBA-IMAGE "Stencil" 100 NORMAL-MODE)))
    (gimp-image-add-layer image stencil-layer -1)
	(plug-in-grid 1 image stencil-layer 6 (/ width 3) 0 '(0 0 0) 255 6 (/ height 3) 0 '(0 0 0) 255 0 0 0 '(0 0 0) 100)
	
;;;;create stencil-channel
	(gimp-selection-layer-alpha stencil-layer)
	(gimp-selection-save image)
	(set! stencil-channel (car (gimp-image-get-active-drawable image)))	
	(gimp-channel-set-opacity stencil-channel 100)	
	(gimp-drawable-set-name stencil-channel "stencil-channel")
	(plug-in-gauss-rle2 RUN-NONINTERACTIVE image stencil-channel 5 5)
	
;;;;bumpmap the image-layer	
	(plug-in-bump-map 1 image image-layer stencil-channel 135 45 65 0 0 0 0 TRUE TRUE 0)
	
;;;;apply the highlight	
	(script-fu-drop-shadow image image-layer 8 8 15 '(255 255 255) 100 TRUE)
	
;;;;apply the shadow
	(script-fu-drop-shadow image image-layer -8 -8 15 '(0 0 0) 100 TRUE)
	
	(gimp-selection-none image)
	(plug-in-autocrop 1 image image-layer)
	(set! image-layer (car (gimp-image-merge-visible-layers image EXPAND-AS-NECESSARY)))
    (gimp-drawable-set-name image-layer "image-layer")

;;;;deepen the image colors
    (gimp-image-set-active-layer image image-layer)
	(set! selblur-layer (car (gimp-layer-copy image-layer TRUE)))
	(gimp-image-add-layer image selblur-layer -1)
	(gimp-drawable-set-name selblur-layer "selblur Layer")
	(plug-in-sel-gauss 1 image selblur-layer 5.00 50)
	(gimp-layer-set-mode selblur-layer GRAIN-MERGE-MODE)
	(gimp-layer-set-opacity selblur-layer 70)		
 
;;;;create the gloss-layer
    (set! gloss-layer (car (gimp-layer-new image width height RGBA-IMAGE "Gloss Layer" 100 SCREEN-MODE)))
    (gimp-image-add-layer image gloss-layer -1)
	(gimp-selection-layer-alpha image-layer)
	(gimp-context-set-foreground '(0 0 0))
	(gimp-edit-fill gloss-layer FOREGROUND-FILL)

;;;;create channel
	(gimp-selection-layer-alpha image-layer)
	(gimp-selection-save image)
	(set! image-channel (car (gimp-image-get-active-drawable image)))	
	(gimp-channel-set-opacity image-channel 100)	
	(gimp-drawable-set-name image-channel "image-channel")
	(gimp-image-set-active-layer image image-layer)
    (gimp-selection-none image)	
    
(plug-in-lighting 1 
	    image              ; IMAGE
		gloss-layer        ; DRAWABLE
		image-channel      ; BUMP MAP
		0                  ; ENVIRONMENT MAP
		TRUE               ; ENABLE BUMPMAPPING
		FALSE              ; ENABLE ENVMAPPING
		0                  ; TYPE OF MAPPING
		1                  ; TYPE OF LIGHTSOURCE 
		'(255 255 255)     ; LIGHTSOURCE COLOR
		-10                ; LIGHTSOURCE POS X
		0                  ; LIGHTSOURCE POS Y
		0.5                ; LIGHTSOURCE POS Z
		-10                ; LIGHTSOURCE DIR X
		0                  ; LIGHTSOURCE DIR Y
		0.5                ; LIGHTSOURCE DIR Z
		5               ; AMBIANT INTENSITY (GLOWING)
		1             ; DIFFUSE INTENSITY (BRIGHT)
		1             ; DIFFUSE REFLECTIVITY (INTENSITY)
		5              ; SPECULAR REFLECTIVITY (SHINY)
		30             ; HIGHLIGHT (POLISHED)
		TRUE               ; ANTIALIASING
		FALSE              ; CREATE NEW IMAGE
		FALSE)	           ; MAKE BACKGROUND TRANSPARENT

    (set! image-layer (car (gimp-image-merge-visible-layers image EXPAND-AS-NECESSARY)))
    (gimp-drawable-set-name image-layer "image-layer")		

    (gimp-layer-resize-to-image-size image-layer)    
 		

    
; *******************************************start 3d Image Object
;

	
			(let*
				(
					;; Matching variables
					(cube-layer (car (gimp-layer-copy image-layer TRUE)))
                      (img-width (car (gimp-drawable-width image-layer)))
				      (img-height (car (gimp-drawable-height image-layer)))
                      (frames (+ in-frames 1))
					  (activeLayer 0)
				)
		
				;; Add a layers
                      (gimp-image-add-layer image cube-layer -1)
                     
				;; name the layers
				(gimp-drawable-set-name cube-layer "Rubiks Cube")
                     			
						
				;; Render 3d image object using G'MIC.
				(plug-in-gmic 1 image cube-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gimp_animate_imageobject3d " 
                                (number->string frames) ",1,0,toto,1,"
								(number->string img-width) ","
                                (number->string img-height) ",2,0.5,21,45,0,45,0,0,-100,0,0,0.5,21,225,0,45,0,0,-100,0,0"
                                                                
					)
				)
				(gimp-image-remove-layer image image-layer)
				(set! activeLayer (car (gimp-image-get-active-layer image)))
				(gimp-image-remove-layer image activeLayer)
				(set! image-layer (car (gimp-image-get-active-layer image)))
				(gimp-drawable-set-name image-layer "Rubiks Cube")
           )          
; *******************************************end 3d Image Object
            
	
	
	
	
    
	(gimp-displays-flush)
	(gimp-image-undo-group-end image)
	(gimp-context-pop)
    



 )
) 



(script-fu-register "script-fu-rubiks-cube"        		    
                    "Rubiks Cube"
                     "Creates a Rubics Cube from Image, uses GMIC to map the cube"
                    "Graechan"
                    "Graechan"
                    "February 2012"
                    "RGB*"
                    SF-IMAGE      "image"      0
                    SF-DRAWABLE   "drawable"   0
					SF-ADJUSTMENT "Frames for Animation (set to 1 for no animation)" '(10 1 100 1 10 0 1)
                    
)

(script-fu-menu-register "script-fu-rubiks-cube" "<Image>/Script-Fu/Map/")


